'use strict';

exports.BifrostFormQuestionType = void 0;
(function (BifrostFormQuestionType) {
    BifrostFormQuestionType["TEXT_INPUT"] = "TEXT_INPUT";
    BifrostFormQuestionType["EMAIL"] = "EMAIL";
    BifrostFormQuestionType["PHONE"] = "PHONE";
    BifrostFormQuestionType["TEXT_AREA"] = "TEXT_AREA";
    BifrostFormQuestionType["TOGGLE_BUTTON_GROUP"] = "TOGGLE_BUTTON_GROUP";
    BifrostFormQuestionType["SELECT_DATE_RANGE"] = "SELECT_DATE_RANGE";
    BifrostFormQuestionType["MULTI_SELECT_DATE_RANGE"] = "MULTI_SELECT_DATE_RANGE";
    // Multi-Stage
    BifrostFormQuestionType["MULTI_STAGE_SMART_DATE_SELECTOR"] = "MULTI_STAGE_SMART_DATE_SELECTOR";
    BifrostFormQuestionType["MULTI_STAGE_REASON_FOR_TRAVEL"] = "MULTI_STAGE_REASON_FOR_TRAVEL";
    BifrostFormQuestionType["SPLIT_TEXT_INPUT"] = "SPLIT_TEXT_INPUT";
})(exports.BifrostFormQuestionType || (exports.BifrostFormQuestionType = {}));

exports.ReservedBifrostFormQuestionIds = void 0;
(function (ReservedBifrostFormQuestionIds) {
    ReservedBifrostFormQuestionIds["FIRST_NAME"] = "First Name";
    ReservedBifrostFormQuestionIds["LAST_NAME"] = "Last Name";
    ReservedBifrostFormQuestionIds["EMAIL"] = "Email";
    ReservedBifrostFormQuestionIds["PHONE"] = "Phone";
    ReservedBifrostFormQuestionIds["INQUIRY_DETAILS"] = "Inquiry Details";
    ReservedBifrostFormQuestionIds["REASON_FOR_TRAVEL"] = "Reason for Travel";
    ReservedBifrostFormQuestionIds["ARE_ITINERARY_DATES_FLEXIBLE"] = "Are Itinerary Dates Flexible";
    // Dates
    ReservedBifrostFormQuestionIds["DATES"] = "Dates";
    ReservedBifrostFormQuestionIds["POTENTIAL_DATES"] = "Potential Dates";
    ReservedBifrostFormQuestionIds["FLEXIBLE_DATE_DESCRIPTION"] = "Flexible Date Description";
    ReservedBifrostFormQuestionIds["ESTIMATED_GUEST_COUNT"] = "Estimated Guest Count";
    ReservedBifrostFormQuestionIds["COUNT_OF_ROOMS_NEEDED"] = "Count of Rooms Needed";
    ReservedBifrostFormQuestionIds["PAYMENT_SPLIT"] = "Payment Split";
    // Multi-Stage
    ReservedBifrostFormQuestionIds["CALENDAR_DATES"] = "Calendar Dates";
    ReservedBifrostFormQuestionIds["ReasonForTravelWithDetails"] = "Reason For Travel With Details";
})(exports.ReservedBifrostFormQuestionIds || (exports.ReservedBifrostFormQuestionIds = {}));

const mockRenderableMultiStageSmartDateSelectorBifrostFormQuestion = {
    type: exports.BifrostFormQuestionType.MULTI_STAGE_SMART_DATE_SELECTOR,
    bifrostFormQuestionId: exports.ReservedBifrostFormQuestionIds.CALENDAR_DATES,
    chatLabel: "",
    label: "Date details",
};
const mockRenderableMultiStageReasonForTravelBifrostFormQuestion = {
    type: exports.BifrostFormQuestionType.MULTI_STAGE_REASON_FOR_TRAVEL,
    bifrostFormQuestionId: exports.ReservedBifrostFormQuestionIds.ReasonForTravelWithDetails,
    chatLabel: "",
    label: "",
};

exports.BifrostFormQuestionResponseType = void 0;
(function (BifrostFormQuestionResponseType) {
    BifrostFormQuestionResponseType["TEXT"] = "TEXT";
    BifrostFormQuestionResponseType["PHONE_NUMBER"] = "PHONE_NUMBER";
    BifrostFormQuestionResponseType["EMAIL"] = "EMAIL";
    BifrostFormQuestionResponseType["CALENDAR_DATE_RANGE"] = "CALENDAR_DATE_RANGE";
    BifrostFormQuestionResponseType["MULTI_CALENDAR_DATE_RANGE"] = "MULTI_CALENDAR_DATE_RANGE";
    // Multi-Stage
    BifrostFormQuestionResponseType["MULTI_STAGE_SMART_DATE"] = "MULTI_STAGE_SMART_DATE";
    BifrostFormQuestionResponseType["MULTI_STAGE_REASON_FOR_TRAVEL"] = "MULTI_STAGE_REASON_FOR_TRAVEL";
    BifrostFormQuestionResponseType["SPLIT_TEXT"] = "SPLIT_TEXT";
})(exports.BifrostFormQuestionResponseType || (exports.BifrostFormQuestionResponseType = {}));

exports.ReservedBifrostReasonForTravelOptionValues = void 0;
(function (ReservedBifrostReasonForTravelOptionValues) {
    ReservedBifrostReasonForTravelOptionValues["BUSINESS"] = "BUSINESS";
    ReservedBifrostReasonForTravelOptionValues["SOCIAL"] = "SOCIAL";
    ReservedBifrostReasonForTravelOptionValues["OTHER"] = "OTHER";
    ReservedBifrostReasonForTravelOptionValues["EXTENDED_STAY"] = "EXTENDED_STAY";
})(exports.ReservedBifrostReasonForTravelOptionValues || (exports.ReservedBifrostReasonForTravelOptionValues = {}));
exports.ReservedBifrostSplitPaymentOptionValues = void 0;
(function (ReservedBifrostSplitPaymentOptionValues) {
    ReservedBifrostSplitPaymentOptionValues["SINGLE_PAYER"] = "SINGLE_PAYER";
    ReservedBifrostSplitPaymentOptionValues["SPLIT_PAYER"] = "SPLIT_PAYER";
})(exports.ReservedBifrostSplitPaymentOptionValues || (exports.ReservedBifrostSplitPaymentOptionValues = {}));
exports.ReservedBifrostDateFlexibilityOptionValues = void 0;
(function (ReservedBifrostDateFlexibilityOptionValues) {
    ReservedBifrostDateFlexibilityOptionValues["FIRM_DATES"] = "FIRM_DATES";
    ReservedBifrostDateFlexibilityOptionValues["FLEXIBLE_DATES"] = "FLEXIBLE_DATES";
    ReservedBifrostDateFlexibilityOptionValues["STILL_DECIDING"] = "STILL_DECIDING";
})(exports.ReservedBifrostDateFlexibilityOptionValues || (exports.ReservedBifrostDateFlexibilityOptionValues = {}));

const mockBifrostFormQuestionMultiStageReasonForTravelResponseEmpty = {
    type: exports.BifrostFormQuestionResponseType.MULTI_STAGE_SMART_DATE,
    responseValue: {
        reasonForTravel: undefined,
        companyName: undefined,
        websiteUrl: undefined,
    },
};
const mockBifrostFormQuestionMultiStageReasonForTravelResponseSocialReason = {
    type: exports.BifrostFormQuestionResponseType.MULTI_STAGE_SMART_DATE,
    responseValue: {
        reasonForTravel: exports.ReservedBifrostReasonForTravelOptionValues.SOCIAL,
    },
};
const mockBifrostFormQuestionMultiStageReasonForTravelResponseBusinessReasonNoDetail = {
    type: exports.BifrostFormQuestionResponseType.MULTI_STAGE_SMART_DATE,
    responseValue: {
        reasonForTravel: exports.ReservedBifrostReasonForTravelOptionValues.BUSINESS,
    },
};
const mockBifrostFormQuestionMultiStageReasonForTravelResponseBusinessReasonWithCompanyNameDetail = {
    type: exports.BifrostFormQuestionResponseType.MULTI_STAGE_SMART_DATE,
    responseValue: {
        reasonForTravel: exports.ReservedBifrostReasonForTravelOptionValues.BUSINESS,
        companyName: "Toyota",
    },
};
const mockBifrostFormQuestionMultiStageReasonForTravelResponseBusinessReasonCompletedDetail = {
    type: exports.BifrostFormQuestionResponseType.MULTI_STAGE_SMART_DATE,
    responseValue: {
        reasonForTravel: exports.ReservedBifrostReasonForTravelOptionValues.BUSINESS,
        companyName: "Toyota",
        websiteUrl: "https://www.toyota.com/",
    },
};

const mock7July2025CalendarDate = {
    day: 7,
    month: 7,
    year: 2025,
};
const mock10July2025CalendarDate = {
    day: 10,
    month: 7,
    year: 2025,
};
const mock13July2025CalendarDate = {
    day: 13,
    month: 7,
    year: 2025,
};
const mock15July2025CalendarDate = {
    day: 15,
    month: 7,
    year: 2025,
};

const mockBifrostFormQuestionMultiStageSmartDateResponseEmpty = {
    type: exports.BifrostFormQuestionResponseType.MULTI_STAGE_SMART_DATE,
    responseValue: {
        dateFlexibility: undefined,
        descriptionOfPotentialCalendarDates: undefined,
        calendarDateRanges: undefined,
    },
};
const mockBifrostFormQuestionMultiStageSmartDateResponseFirmDatesUnsetDates = {
    type: exports.BifrostFormQuestionResponseType.MULTI_STAGE_SMART_DATE,
    responseValue: {
        dateFlexibility: exports.ReservedBifrostDateFlexibilityOptionValues.FIRM_DATES,
        descriptionOfPotentialCalendarDates: undefined,
        calendarDateRanges: undefined,
    },
};
const mockBifrostFormQuestionMultiStageSmartDateResponseFirmDatesWithSetDates = {
    type: exports.BifrostFormQuestionResponseType.MULTI_STAGE_SMART_DATE,
    responseValue: {
        dateFlexibility: exports.ReservedBifrostDateFlexibilityOptionValues.FIRM_DATES,
        descriptionOfPotentialCalendarDates: undefined,
        calendarDateRanges: [
            {
                startCalendarDate: mock7July2025CalendarDate,
                endCalendarDate: mock10July2025CalendarDate,
            },
        ],
    },
};
const mockBifrostFormQuestionMultiStageSmartDateResponseFlexibleDatesWithUnsetDates = {
    type: exports.BifrostFormQuestionResponseType.MULTI_STAGE_SMART_DATE,
    responseValue: {
        dateFlexibility: exports.ReservedBifrostDateFlexibilityOptionValues.FLEXIBLE_DATES,
        descriptionOfPotentialCalendarDates: undefined,
        calendarDateRanges: undefined,
    },
};
const mockBifrostFormQuestionMultiStageSmartDateResponseFlexibleDatesWithSetDates = {
    type: exports.BifrostFormQuestionResponseType.MULTI_STAGE_SMART_DATE,
    responseValue: {
        dateFlexibility: exports.ReservedBifrostDateFlexibilityOptionValues.FLEXIBLE_DATES,
        descriptionOfPotentialCalendarDates: undefined,
        calendarDateRanges: [
            {
                startCalendarDate: mock7July2025CalendarDate,
                endCalendarDate: mock10July2025CalendarDate,
            },
            {
                startCalendarDate: mock13July2025CalendarDate,
                endCalendarDate: mock15July2025CalendarDate,
            },
        ],
    },
};
const mockBifrostFormQuestionMultiStageSmartDateResponseStillDecidingDatesWithUnsetDatesWithDescription = {
    type: exports.BifrostFormQuestionResponseType.MULTI_STAGE_SMART_DATE,
    responseValue: {
        dateFlexibility: exports.ReservedBifrostDateFlexibilityOptionValues.STILL_DECIDING,
        descriptionOfPotentialCalendarDates: "sometime around this upcoming July",
        calendarDateRanges: undefined,
    },
};
const mockBifrostFormQuestionMultiStageSmartDateResponseStillDecidingDatesWithSetDatesWithDescription = {
    type: exports.BifrostFormQuestionResponseType.MULTI_STAGE_SMART_DATE,
    responseValue: {
        dateFlexibility: exports.ReservedBifrostDateFlexibilityOptionValues.STILL_DECIDING,
        descriptionOfPotentialCalendarDates: "sometime around this upcoming July",
        calendarDateRanges: [
            {
                startCalendarDate: mock7July2025CalendarDate,
                endCalendarDate: mock10July2025CalendarDate,
            },
        ],
    },
};

exports.ItineraryOfferOriginatorType = void 0;
(function (ItineraryOfferOriginatorType) {
    ItineraryOfferOriginatorType["KISMET_AI"] = "KISMET_AI";
    ItineraryOfferOriginatorType["GUEST"] = "GUEST";
    ItineraryOfferOriginatorType["SALES_AGENT"] = "SALES_AGENT";
})(exports.ItineraryOfferOriginatorType || (exports.ItineraryOfferOriginatorType = {}));
exports.RenderableItineraryEventOfferApprovalStatus = void 0;
(function (RenderableItineraryEventOfferApprovalStatus) {
    RenderableItineraryEventOfferApprovalStatus["PENDING"] = "Pending";
})(exports.RenderableItineraryEventOfferApprovalStatus || (exports.RenderableItineraryEventOfferApprovalStatus = {}));

const mockRunOfHouseRenderableItineraryHotelRoomOffer = {
    hotelRoomOfferId: `78901qerjweqrwerhv2`,
    runOfHouseDetails: {},
    countOffered: 5,
    countAvailable: 5,
    offerPriceInCents: 80000,
    listPriceInCents: 100000,
    hotelRoomName: `Run of House`,
    hotelRoomDescription: `A versatile room option that offers excellent value and flexibility.`,
    verboseHotelRoomDescription: `Our 'Run of House' room type ensures you receive one of our high-quality rooms at an unbeatable price. Room assignments are made upon check-in, based on availability, providing you with the best possible accommodation. This option is ideal for guests seeking value without sacrificing comfort.`,
    heroImageUrl: `https://images.pexels.com/photos/271618/pexels-photo-271618.jpeg`,
    hotelRoomImageUrls: [
        `https://images.pexels.com/photos/271618/pexels-photo-271618.jpeg`,
    ],
};

exports.EitherResponseType = void 0;
(function (EitherResponseType) {
    EitherResponseType["SUCCESS"] = "SUCCESS";
    EitherResponseType["ERROR"] = "ERROR";
})(exports.EitherResponseType || (exports.EitherResponseType = {}));
const successResponse = (data) => ({
    type: exports.EitherResponseType.SUCCESS,
    success: data,
});
const errorResponse = (error) => ({
    type: exports.EitherResponseType.ERROR,
    error: error,
});

const bundleBifrostFormQuestionWithResponse = ({ bifrostFormQuestion, }) => {
    let bifrostFormQuestionWithResponse;
    if (bifrostFormQuestion.type === exports.BifrostFormQuestionType.TEXT_INPUT) {
        bifrostFormQuestionWithResponse = {
            responseType: exports.BifrostFormQuestionResponseType.TEXT,
            bifrostFormQuestion,
            responseData: {
                type: exports.BifrostFormQuestionResponseType.TEXT,
                responseValue: "",
            },
        };
    }
    else if (bifrostFormQuestion.type === exports.BifrostFormQuestionType.EMAIL) {
        bifrostFormQuestionWithResponse = {
            responseType: exports.BifrostFormQuestionResponseType.EMAIL,
            bifrostFormQuestion,
            responseData: {
                type: exports.BifrostFormQuestionResponseType.EMAIL,
                responseValue: "",
            },
        };
    }
    else if (bifrostFormQuestion.type === exports.BifrostFormQuestionType.PHONE) {
        bifrostFormQuestionWithResponse = {
            responseType: exports.BifrostFormQuestionResponseType.PHONE_NUMBER,
            bifrostFormQuestion,
            responseData: {
                type: exports.BifrostFormQuestionResponseType.PHONE_NUMBER,
                responseValue: "",
            },
        };
    }
    else if (bifrostFormQuestion.type === exports.BifrostFormQuestionType.TEXT_AREA) {
        bifrostFormQuestionWithResponse = {
            responseType: exports.BifrostFormQuestionResponseType.TEXT,
            bifrostFormQuestion,
            responseData: {
                type: exports.BifrostFormQuestionResponseType.TEXT,
                responseValue: "",
            },
        };
    }
    else if (bifrostFormQuestion.type === exports.BifrostFormQuestionType.TOGGLE_BUTTON_GROUP) {
        bifrostFormQuestionWithResponse = {
            responseType: exports.BifrostFormQuestionResponseType.TEXT,
            bifrostFormQuestion,
            responseData: {
                type: exports.BifrostFormQuestionResponseType.TEXT,
                responseValue: "",
            },
        };
    }
    else if (bifrostFormQuestion.type === exports.BifrostFormQuestionType.SELECT_DATE_RANGE) {
        bifrostFormQuestionWithResponse = {
            responseType: exports.BifrostFormQuestionResponseType.CALENDAR_DATE_RANGE,
            bifrostFormQuestion,
            responseData: {
                type: exports.BifrostFormQuestionResponseType.CALENDAR_DATE_RANGE,
                responseValue: {
                    startCalendarDate: undefined,
                    endCalendarDate: undefined,
                },
            },
        };
    }
    else if (bifrostFormQuestion.type === exports.BifrostFormQuestionType.MULTI_SELECT_DATE_RANGE) {
        bifrostFormQuestionWithResponse = {
            responseType: exports.BifrostFormQuestionResponseType.MULTI_CALENDAR_DATE_RANGE,
            bifrostFormQuestion,
            responseData: {
                type: exports.BifrostFormQuestionResponseType.MULTI_CALENDAR_DATE_RANGE,
                responseValue: [
                    {
                        startCalendarDate: undefined,
                        endCalendarDate: undefined,
                    },
                ],
            },
        };
    }
    else if (bifrostFormQuestion.type === exports.BifrostFormQuestionType.SPLIT_TEXT_INPUT) {
        bifrostFormQuestionWithResponse = {
            responseType: exports.BifrostFormQuestionResponseType.SPLIT_TEXT,
            bifrostFormQuestion,
            responseData: {
                type: exports.BifrostFormQuestionResponseType.SPLIT_TEXT,
                responseValue: {
                    left: "",
                    right: "",
                },
            },
        };
    }
    else {
        throw new Error(`Unsupported BifrostFormQuestionType: ${bifrostFormQuestion.type}`);
    }
    return { bifrostFormQuestionWithResponse };
};

const updateBifrostFormQuestionWithResponse = ({ previousBifrostFormQuestionWithResponse, updatedBifrostFormQuestionResponse, }) => {
    if (previousBifrostFormQuestionWithResponse.responseType ===
        exports.BifrostFormQuestionResponseType.TEXT &&
        updatedBifrostFormQuestionResponse.type ===
            exports.BifrostFormQuestionResponseType.TEXT) {
        return Object.assign(Object.assign({}, previousBifrostFormQuestionWithResponse), { responseData: updatedBifrostFormQuestionResponse });
    }
    else if (previousBifrostFormQuestionWithResponse.responseType ===
        exports.BifrostFormQuestionResponseType.EMAIL &&
        updatedBifrostFormQuestionResponse.type ===
            exports.BifrostFormQuestionResponseType.EMAIL) {
        return Object.assign(Object.assign({}, previousBifrostFormQuestionWithResponse), { responseData: updatedBifrostFormQuestionResponse });
    }
    else if (previousBifrostFormQuestionWithResponse.responseType ===
        exports.BifrostFormQuestionResponseType.PHONE_NUMBER &&
        updatedBifrostFormQuestionResponse.type ===
            exports.BifrostFormQuestionResponseType.PHONE_NUMBER) {
        return Object.assign(Object.assign({}, previousBifrostFormQuestionWithResponse), { responseData: updatedBifrostFormQuestionResponse });
    }
    else if (previousBifrostFormQuestionWithResponse.responseType ===
        exports.BifrostFormQuestionResponseType.CALENDAR_DATE_RANGE &&
        updatedBifrostFormQuestionResponse.type ===
            exports.BifrostFormQuestionResponseType.CALENDAR_DATE_RANGE) {
        return Object.assign(Object.assign({}, previousBifrostFormQuestionWithResponse), { responseData: updatedBifrostFormQuestionResponse });
    }
    else if (previousBifrostFormQuestionWithResponse.responseType ===
        exports.BifrostFormQuestionResponseType.MULTI_CALENDAR_DATE_RANGE &&
        updatedBifrostFormQuestionResponse.type ===
            exports.BifrostFormQuestionResponseType.MULTI_CALENDAR_DATE_RANGE) {
        return Object.assign(Object.assign({}, previousBifrostFormQuestionWithResponse), { responseData: updatedBifrostFormQuestionResponse });
    }
    else if (previousBifrostFormQuestionWithResponse.responseType ===
        exports.BifrostFormQuestionResponseType.SPLIT_TEXT &&
        updatedBifrostFormQuestionResponse.type ===
            exports.BifrostFormQuestionResponseType.SPLIT_TEXT) {
        return Object.assign(Object.assign({}, previousBifrostFormQuestionWithResponse), { responseData: updatedBifrostFormQuestionResponse });
    }
    return previousBifrostFormQuestionWithResponse;
};

const deepEqual = (object1, object2) => {
    if (object1 === undefined || object2 === undefined) {
        if (object1 === undefined && object2 === undefined) {
            return true;
        }
        return false;
    }
    const keys1 = Object.keys(object1);
    const keys2 = Object.keys(object2);
    if (keys1.length !== keys2.length) {
        return false;
    }
    for (const key of keys1) {
        const val1 = object1[key];
        const val2 = object2[key];
        const areObjects = val1 instanceof Object && val2 instanceof Object;
        if (areObjects &&
            !deepEqual(val1, val2)) {
            return false;
        }
        else if (!areObjects && val1 !== val2) {
            return false;
        }
    }
    return true;
};

const useReactStateCache = ({ previousValue, updatedValue, }) => {
    if (deepEqual(updatedValue, previousValue)) {
        return previousValue;
    }
    else {
        return updatedValue;
    }
};

/* eslint-disable @typescript-eslint/no-explicit-any */
const deepClone = (obj) => {
    if (obj === null || typeof obj !== "object") {
        return obj;
    }
    if (Array.isArray(obj)) {
        return obj.map((item) => deepClone(item));
    }
    const clonedObj = {};
    for (const key in obj) {
        // Use Object.prototype.hasOwnProperty.call to avoid accessing the prototype directly
        if (Object.prototype.hasOwnProperty.call(obj, key)) {
            clonedObj[key] = deepClone(obj[key]);
        }
    }
    return clonedObj;
};

exports.RenderedCalendarDateFormat = void 0;
(function (RenderedCalendarDateFormat) {
    // Example: 12/13/2027
    RenderedCalendarDateFormat["MM_SLASH_DD_SLASH_YY"] = "MM_SLASH_DD_SLASH_YY";
    // Example: Dec 13 (current year is hidden)
    // Example: Dec 13, 2027 (non-current year is shown)
    RenderedCalendarDateFormat["ABBREVIATED_MONTH_DAY_OPTIONAL_YEAR"] = "ABBREVIATED_MONTH_DAY_OPTIONAL_YEAR";
    // Example: January 3, 2025
    RenderedCalendarDateFormat["MONTH_DAY_YEAR"] = "MONTH_DAY_YEAR";
    // Example: January
    RenderedCalendarDateFormat["MONTH"] = "MONTH";
})(exports.RenderedCalendarDateFormat || (exports.RenderedCalendarDateFormat = {}));

const renderMMSlashDDSlashYYFormatCalendarDate = ({ calendarDate, }) => {
    const month = calendarDate.month.toString().padStart(2, "0");
    const day = calendarDate.day.toString().padStart(2, "0");
    const year = calendarDate.year.toString().slice(-2);
    return `${month}/${day}/${year}`;
};

const renderAbbreviatedMonthDayOptionalYearFormatCalendarDate = ({ calendarDate, }) => {
    const { year, month, day, timeZone } = calendarDate;
    // Create a JavaScript Date object using the CalendarDate information
    const jsDate = new Date(Date.UTC(year, month - 1, day));
    // Use Intl.DateTimeFormat to format the date as "Dec 13"
    const formatter = new Intl.DateTimeFormat("en-US", {
        month: "short",
        day: "numeric",
        timeZone: timeZone || "UTC", // Default to UTC if timeZone is undefined
    });
    return formatter.format(jsDate);
};

const renderMonthDayYearFormatCalendarDate = ({ calendarDate, }) => {
    const { year, month, day } = calendarDate;
    // Validate month and day
    if (month < 1 || month > 12) {
        throw new Error(`Invalid month: ${month}. Month should be between 1 and 12.`);
    }
    if (day < 1 || day > 31) {
        // Basic validation; can be enhanced
        throw new Error(`Invalid day: ${day}. Day should be between 1 and 31.`);
    }
    // Create a Date object (Note: months are zero-indexed in JavaScript Date)
    const date = new Date(year, month - 1, day);
    // Use Intl.DateTimeFormat for locale-aware formatting
    const formatter = new Intl.DateTimeFormat("en-US", {
        year: "numeric",
        month: "long",
        day: "numeric",
    });
    return formatter.format(date);
};

const renderMonthFormatCalendarDate = ({ calendarDate, }) => {
    const { year, month, day } = calendarDate;
    // Create a JavaScript Date object. Note: month is zero-indexed in JS.
    const date = new Date(year, month - 1, day);
    // Use Intl.DateTimeFormat to get the full month name
    const formatter = new Intl.DateTimeFormat("en-US", { month: "long" });
    return formatter.format(date);
};

const renderCalendarDate = ({ calendarDate, format, }) => {
    if (format === exports.RenderedCalendarDateFormat.MM_SLASH_DD_SLASH_YY) {
        return renderMMSlashDDSlashYYFormatCalendarDate({
            calendarDate,
        });
    }
    else if (format === exports.RenderedCalendarDateFormat.ABBREVIATED_MONTH_DAY_OPTIONAL_YEAR) {
        return renderAbbreviatedMonthDayOptionalYearFormatCalendarDate({
            calendarDate,
        });
    }
    else if (format === exports.RenderedCalendarDateFormat.MONTH_DAY_YEAR) {
        return renderMonthDayYearFormatCalendarDate({
            calendarDate,
        });
    }
    else if (format === exports.RenderedCalendarDateFormat.MONTH) {
        return renderMonthFormatCalendarDate({
            calendarDate,
        });
    }
    else {
        throw new Error(`Unsupported format: ${format}`);
    }
};

exports.RenderedCalendarDateRangeJoinFormat = void 0;
(function (RenderedCalendarDateRangeJoinFormat) {
    // Example: 12/13/2027 - 12/14/2027
    RenderedCalendarDateRangeJoinFormat["SPACE_DASH_SPACE"] = "SPACE_DASH_SPACE";
})(exports.RenderedCalendarDateRangeJoinFormat || (exports.RenderedCalendarDateRangeJoinFormat = {}));

const renderCalendarDateRange = ({ calendarDateRange, renderedCalendarDateFormat, renderedCalendarDateRangeJoinFormat, collapseStrategy, }) => {
    if (collapseStrategy.collapseSameDay &&
        calendarDateRange.startCalendarDate.year ===
            calendarDateRange.endCalendarDate.year &&
        calendarDateRange.startCalendarDate.month ===
            calendarDateRange.endCalendarDate.month &&
        calendarDateRange.startCalendarDate.day ===
            calendarDateRange.endCalendarDate.day) {
        const startDate = renderCalendarDate({
            calendarDate: calendarDateRange.startCalendarDate,
            format: renderedCalendarDateFormat,
        });
        return startDate;
    }
    if (collapseStrategy.collapseSameMonth &&
        calendarDateRange.startCalendarDate.year ===
            calendarDateRange.endCalendarDate.year &&
        calendarDateRange.startCalendarDate.month ===
            calendarDateRange.endCalendarDate.month) {
        if (renderedCalendarDateFormat === exports.RenderedCalendarDateFormat.MONTH_DAY_YEAR) {
            const month = renderCalendarDate({
                calendarDate: calendarDateRange.startCalendarDate,
                format: exports.RenderedCalendarDateFormat.MONTH,
            });
            return `${month} ${calendarDateRange.startCalendarDate.day} - ${calendarDateRange.endCalendarDate.day}, ${calendarDateRange.startCalendarDate.year}`;
        }
        const startDate = renderCalendarDate({
            calendarDate: calendarDateRange.startCalendarDate,
            format: renderedCalendarDateFormat,
        });
        return `${startDate} - ${calendarDateRange.endCalendarDate.day}`;
    }
    const startDate = renderCalendarDate({
        calendarDate: calendarDateRange.startCalendarDate,
        format: renderedCalendarDateFormat,
    });
    const endDate = renderCalendarDate({
        calendarDate: calendarDateRange.endCalendarDate,
        format: renderedCalendarDateFormat,
    });
    if (renderedCalendarDateRangeJoinFormat ===
        exports.RenderedCalendarDateRangeJoinFormat.SPACE_DASH_SPACE) {
        return `${startDate} - ${endDate}`;
    }
    else {
        throw new Error(`Unsupported format: ${renderedCalendarDateRangeJoinFormat}`);
    }
};

const convertCalendarDateToDateAdjustedForTimezone = ({ calendarDate, }) => {
    const utcDate = new Date(Date.UTC(calendarDate.year, calendarDate.month - 1, calendarDate.day)); // month is zero-indexed in Date constructor
    if (!calendarDate.timeZone) {
        return utcDate; // Return UTC date if timeZone is not provided
    }
    const userTimezoneDate = new Date(utcDate.toLocaleString("en-US", { timeZone: calendarDate.timeZone }));
    return userTimezoneDate;
};

exports.CalendarDateComarison = void 0;
(function (CalendarDateComarison) {
    CalendarDateComarison[CalendarDateComarison["FIRST_DATE_OCCURS_BEFORE_SECOND_DATE"] = -1] = "FIRST_DATE_OCCURS_BEFORE_SECOND_DATE";
    CalendarDateComarison[CalendarDateComarison["FIRST_DATE_OCCURS_AFTER_SECOND_DATE"] = 1] = "FIRST_DATE_OCCURS_AFTER_SECOND_DATE";
    CalendarDateComarison[CalendarDateComarison["DATES_ARE_EQUAL"] = 0] = "DATES_ARE_EQUAL";
})(exports.CalendarDateComarison || (exports.CalendarDateComarison = {}));
function compareCalendarDates({ firstCalendarDate, secondCalendarDate, }) {
    const firstDate = convertCalendarDateToDateAdjustedForTimezone({
        calendarDate: firstCalendarDate,
    });
    const secondDate = convertCalendarDateToDateAdjustedForTimezone({
        calendarDate: secondCalendarDate,
    });
    if (firstDate < secondDate)
        return exports.CalendarDateComarison.FIRST_DATE_OCCURS_BEFORE_SECOND_DATE;
    if (firstDate > secondDate)
        return exports.CalendarDateComarison.FIRST_DATE_OCCURS_AFTER_SECOND_DATE;
    return exports.CalendarDateComarison.DATES_ARE_EQUAL;
}

const convertLocalCalendarDateToNativeDate = (calendarDate) => {
    const { year, month, day } = calendarDate;
    // JavaScript months are 0-based, subtract 1 from the month to convert it from 1-based to 0-based
    return new Date(year, month - 1, day);
};

const convertNativeDateToLocalCalendarDate = (date) => {
    return {
        year: date.getFullYear(),
        month: date.getMonth() + 1, // JavaScript months are 0-based, so add 1
        day: date.getDate(),
    };
};

const getDaysBetweenCalendarDates = ({ startCalendarDate, endCalendarDate, }) => {
    const start = new Date(startCalendarDate.year, startCalendarDate.month - 1, startCalendarDate.day);
    const end = new Date(endCalendarDate.year, endCalendarDate.month - 1, endCalendarDate.day);
    // Calculate the difference in time
    const diffTime = Math.abs(end.getTime() - start.getTime());
    // Convert time difference to days
    const diffDays = Math.ceil(diffTime / (1000 * 60 * 60 * 24));
    return { days: diffDays };
};

const getTodayCalendarDate = ({ timeZone, }) => {
    const today = new Date();
    return {
        year: today.getFullYear(),
        month: today.getMonth() + 1, // Convert to one-indexed month
        day: today.getDate(),
        timeZone,
    };
};

const getRoomCountFromRenderableItineraryOffer = ({ renderableItineraryOffer, }) => {
    return renderableItineraryOffer.hotelRoomOffers.reduce((acc, hotelRoomOffer) => {
        return acc + hotelRoomOffer.countOffered;
    }, 0);
};

const getTotalListPriceInCentsFromRenderableItineraryOffer = ({ renderableItineraryOffer, }) => {
    const { startCalendarDate, endCalendarDate, hotelRoomOffers } = renderableItineraryOffer;
    const { days: nightsInOffer } = getDaysBetweenCalendarDates({
        startCalendarDate,
        endCalendarDate,
    });
    const totalListPriceInCents = hotelRoomOffers.reduce((acc, hotelRoomOffer) => {
        return (acc +
            hotelRoomOffer.countOffered *
                nightsInOffer *
                hotelRoomOffer.listPriceInCents);
    }, 0);
    return { totalListPriceInCents };
};

const getTotalOfferPriceInCentsFromRenderableItineraryOffer = ({ renderableItineraryOffer, }) => {
    const { startCalendarDate, endCalendarDate, hotelRoomOffers } = renderableItineraryOffer;
    const { days: nightsInOffer } = getDaysBetweenCalendarDates({
        startCalendarDate,
        endCalendarDate,
    });
    const totalOfferPriceInCents = hotelRoomOffers.reduce((acc, hotelRoomOffer) => {
        return (acc +
            hotelRoomOffer.countOffered *
                nightsInOffer *
                hotelRoomOffer.offerPriceInCents);
    }, 0);
    return { totalOfferPriceInCents };
};

const renderDiscount = ({ listPriceInCents, offerPriceInCents, }) => {
    const discount = listPriceInCents
        ? Math.round(((listPriceInCents - offerPriceInCents) / listPriceInCents) * 100)
        : 0;
    return discount > 0 ? `${discount}%  off` : "";
};

const formatPhoneNumber = ({ phoneNumber }) => {
    if (phoneNumber.length < 10) {
        return phoneNumber;
    }
    const areaCode = phoneNumber.slice(0, 3);
    const centralOfficeCode = phoneNumber.slice(3, 6);
    const lineNumber = phoneNumber.slice(6);
    return `(${areaCode})-${centralOfficeCode}-${lineNumber}`;
};

const getDiscountPercent = ({ listPrice, offerPrice, decimalPlaces, }) => {
    let discountPercent;
    if (listPrice === 0) {
        if (offerPrice !== 0) {
            discountPercent = 0;
        }
        else {
            discountPercent = 100;
        }
    }
    else {
        discountPercent = ((listPrice - offerPrice) / listPrice) * 100;
    }
    return discountPercent.toFixed(decimalPlaces);
};

exports.bundleBifrostFormQuestionWithResponse = bundleBifrostFormQuestionWithResponse;
exports.compareCalendarDates = compareCalendarDates;
exports.convertCalendarDateToDateAdjustedForTimezone = convertCalendarDateToDateAdjustedForTimezone;
exports.convertLocalCalendarDateToNativeDate = convertLocalCalendarDateToNativeDate;
exports.convertNativeDateToLocalCalendarDate = convertNativeDateToLocalCalendarDate;
exports.deepClone = deepClone;
exports.deepEqual = deepEqual;
exports.errorResponse = errorResponse;
exports.formatPhoneNumber = formatPhoneNumber;
exports.getDaysBetweenCalendarDates = getDaysBetweenCalendarDates;
exports.getDiscountPercent = getDiscountPercent;
exports.getRoomCountFromRenderableItineraryOffer = getRoomCountFromRenderableItineraryOffer;
exports.getTodayCalendarDate = getTodayCalendarDate;
exports.getTotalListPriceInCentsFromRenderableItineraryOffer = getTotalListPriceInCentsFromRenderableItineraryOffer;
exports.getTotalOfferPriceInCentsFromRenderableItineraryOffer = getTotalOfferPriceInCentsFromRenderableItineraryOffer;
exports.mockBifrostFormQuestionMultiStageReasonForTravelResponseBusinessReasonCompletedDetail = mockBifrostFormQuestionMultiStageReasonForTravelResponseBusinessReasonCompletedDetail;
exports.mockBifrostFormQuestionMultiStageReasonForTravelResponseBusinessReasonNoDetail = mockBifrostFormQuestionMultiStageReasonForTravelResponseBusinessReasonNoDetail;
exports.mockBifrostFormQuestionMultiStageReasonForTravelResponseBusinessReasonWithCompanyNameDetail = mockBifrostFormQuestionMultiStageReasonForTravelResponseBusinessReasonWithCompanyNameDetail;
exports.mockBifrostFormQuestionMultiStageReasonForTravelResponseEmpty = mockBifrostFormQuestionMultiStageReasonForTravelResponseEmpty;
exports.mockBifrostFormQuestionMultiStageReasonForTravelResponseSocialReason = mockBifrostFormQuestionMultiStageReasonForTravelResponseSocialReason;
exports.mockBifrostFormQuestionMultiStageSmartDateResponseEmpty = mockBifrostFormQuestionMultiStageSmartDateResponseEmpty;
exports.mockBifrostFormQuestionMultiStageSmartDateResponseFirmDatesUnsetDates = mockBifrostFormQuestionMultiStageSmartDateResponseFirmDatesUnsetDates;
exports.mockBifrostFormQuestionMultiStageSmartDateResponseFirmDatesWithSetDates = mockBifrostFormQuestionMultiStageSmartDateResponseFirmDatesWithSetDates;
exports.mockBifrostFormQuestionMultiStageSmartDateResponseFlexibleDatesWithSetDates = mockBifrostFormQuestionMultiStageSmartDateResponseFlexibleDatesWithSetDates;
exports.mockBifrostFormQuestionMultiStageSmartDateResponseFlexibleDatesWithUnsetDates = mockBifrostFormQuestionMultiStageSmartDateResponseFlexibleDatesWithUnsetDates;
exports.mockBifrostFormQuestionMultiStageSmartDateResponseStillDecidingDatesWithSetDatesWithDescription = mockBifrostFormQuestionMultiStageSmartDateResponseStillDecidingDatesWithSetDatesWithDescription;
exports.mockBifrostFormQuestionMultiStageSmartDateResponseStillDecidingDatesWithUnsetDatesWithDescription = mockBifrostFormQuestionMultiStageSmartDateResponseStillDecidingDatesWithUnsetDatesWithDescription;
exports.mockRenderableMultiStageReasonForTravelBifrostFormQuestion = mockRenderableMultiStageReasonForTravelBifrostFormQuestion;
exports.mockRenderableMultiStageSmartDateSelectorBifrostFormQuestion = mockRenderableMultiStageSmartDateSelectorBifrostFormQuestion;
exports.mockRunOfHouseRenderableItineraryHotelRoomOffer = mockRunOfHouseRenderableItineraryHotelRoomOffer;
exports.renderCalendarDate = renderCalendarDate;
exports.renderCalendarDateRange = renderCalendarDateRange;
exports.renderDiscount = renderDiscount;
exports.successResponse = successResponse;
exports.updateBifrostFormQuestionWithResponse = updateBifrostFormQuestionWithResponse;
exports.useReactStateCache = useReactStateCache;
